package lecture3

import org.scalameter.*

import java.util.*
import java.util.concurrent.ConcurrentSkipListSet
import scala.collection.*
import scala.collection.parallel.CollectionConverters.IterableIsParallelizable

// TODO : THIS DOES NOT COMPILE
def intersection_no_side_effect(a: GenSet[Int], b: GenSet[Int]) =
  if(a.size < b.size) a.filter(b(_))
  else b.filter(a(_))

@main def intersectionNoSideEffect =
  val seqres = intersection_no_side_effect((0 until 1000).toSet, (0 until 1000 by 4).toSet)
  val parres = intersection_no_side_effect((0 until 1000).par.toSet, (0 until 1000 by 4).par.toSet)
  log(s"Sequential result - ${seqres.size}")
  log(s"Parallel result - ${parres.size}")


